diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index 92297b7da..1410f7417 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -18,7 +18,6 @@ import net.minecraft.core.item.block.ItemBlock;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Math;
-import org.lwjgl.opengl.GL41;
 import org.useless.dragonfly.DisplayPos;
 
 public class ItemModelBlock extends ItemModelStandard {
@@ -43,13 +42,13 @@ public class ItemModelBlock extends ItemModelStandard {
     }
 
     @Override
-    public void render(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, int lightmapCoord, float partialTick, boolean mirrorX) {
+    public void render(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, byte lightIndex, float partialTick, boolean mirrorX) {
         if (!this.blockModel.shouldItemRender3d()) {
-            super.render(tessellator, holder, itemStack, displayPosId, items3d, clusterSize, lightmapCoord, partialTick, mirrorX);
+            super.render(tessellator, holder, itemStack, displayPosId, items3d, clusterSize, lightIndex, partialTick, mirrorX);
             return;
         }
         random.setSeed(187L);
-        GLRenderer.setShader(Shaders.TERRAIN);
+        GLRenderer.setShader(Shaders.ITEM);
         DisplayPos displayPos = getDisplayPos(displayPosId);
         GLRenderer.modelM4f().translate(displayPos.tx, displayPos.ty, displayPos.tz);
         GLRenderer.modelM4f().rotateX(Math.toRadians(displayPos.rx));
@@ -66,47 +65,47 @@ public class ItemModelBlock extends ItemModelStandard {
                 rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sz;
             }
             GLRenderer.modelM4f().translate(rOffX, rOffY, rOffZ);
-            renderSingle(tessellator, holder, itemStack, items3d, lightmapCoord, getColor(itemStack), partialTick, mirrorX);
+            renderSingle(tessellator, holder, itemStack, items3d, lightIndex, getColor(itemStack), partialTick, mirrorX);
             GLRenderer.modelM4f().translate(-rOffX, -rOffY, -rOffZ);
         }
     }
 
     @Override
-    protected void renderSingle(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, int lightmapCoord, int color, float partialTick, boolean mirrorX) {
+    protected void renderSingle(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, byte lightIndex, int color, float partialTick, boolean mirrorX) {
         if (!this.blockModel.shouldItemRender3d()) {
-            super.renderSingle(tessellator, holder, itemStack, items3d, lightmapCoord, color, partialTick, mirrorX);
+            super.renderSingle(tessellator, holder, itemStack, items3d, lightIndex, color, partialTick, mirrorX);
         } else {
             TextureRegistry.worldAtlas.bind();
-            this.blockModel.renderStandalone(tessellator, itemStack.getMetadata(), lightmapCoord);
+            this.blockModel.renderStandalone(tessellator, itemStack.getMetadata(), lightIndex);
         }
     }
 
     @Override
-    public void renderGui(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, int lightmapCoord, float partialTick) {
+    public void renderGui(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, byte lightIndex, float partialTick) {
         if (!this.blockModel.shouldItemRender3d()) {
-            super.renderGui(tessellator, holder, itemStack, x, y, lightmapCoord, partialTick);
+            super.renderGui(tessellator, holder, itemStack, x, y, lightIndex, partialTick);
             return;
         }
         GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.TERRAIN);
+        GLRenderer.setShader(Shaders.ITEM);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.CULL_FACE);
         GLRenderer.modelM4f().translate(x + 8, y + 8, 8);
         GLRenderer.modelM4f().scale(16f, -16f, 16f);
-        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, lightmapCoord, partialTick, false);
+        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, lightIndex, partialTick, false);
         GLRenderer.popFrame();
     }
 
     @Override
-    public void renderItemEntity(@NotNull TessellatorGeneral tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, int lightmap, float partialTick) {
+    public void renderItemEntity(@NotNull TessellatorGeneral tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, byte lightIndex, float partialTick) {
         if (!this.blockModel.shouldItemRender3d()) {
-            super.renderItemEntity(tessellator, itemStack, items3d, clusterSize, ticks, yaw, lightmap, partialTick);
+            super.renderItemEntity(tessellator, itemStack, items3d, clusterSize, ticks, yaw, lightIndex, partialTick);
             return;
         }
         GLRenderer.enableState(State.BLEND);
         GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
-        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, lightmap, partialTick, false);
+        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, lightIndex, partialTick, false);
         GLRenderer.disableState(State.BLEND);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
index d7e1c3749..91db639ab 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBow.java
@@ -19,8 +19,8 @@ public class ItemModelBow extends ItemModelStandard {
     }
 
     @Override
-    protected void renderSingle(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, int lightmapCoord, int color, float partialTick, boolean mirrorX) {
-        super.renderSingle(tessellator, holder, itemStack, items3d, lightmapCoord, color, partialTick, mirrorX);
+    protected void renderSingle(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, boolean items3d, byte lightIndex, int color, float partialTick, boolean mirrorX) {
+        super.renderSingle(tessellator, holder, itemStack, items3d, lightIndex, color, partialTick, mirrorX);
         Item nextArrow = null;
         if (holder instanceof Player player) {
             nextArrow = getNextArrow(player);
@@ -38,7 +38,7 @@ public class ItemModelBow extends ItemModelStandard {
             }
             GLRenderer.modelM4f().translate(0.0001f, 0.0001f, 0);
             GLRenderer.modelM4f().scale(1, 1, 0.999f);
-            renderCoordinate(tessellator, ItemModelDispatcher.getInstance().getDispatch(nextArrow).getIcon(holder, nextArrow.getDefaultStack()), lightmapCoord, color, items3d, mirrorX);
+            renderCoordinate(tessellator, ItemModelDispatcher.getInstance().getDispatch(nextArrow).getIcon(holder, nextArrow.getDefaultStack()), lightIndex, color, items3d, mirrorX);
             GLRenderer.popFrame();
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
index 47d32d723..88dc401bf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
@@ -32,7 +32,7 @@ public class ItemModelMap extends ItemModelStandard {
     }
 
     @Override
-    public void renderFirstPerson(@NotNull TessellatorGeneral tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, int lightmapCoord, float partialTick) {
+    public void renderFirstPerson(@NotNull TessellatorGeneral tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, byte lightIndex, float partialTick) {
         // The map renders very differently from any other item, so has its own custom first person render code
         if (ItemMap.hasInitialized(itemStack)) {
             GLRenderer.pushFrame();
@@ -118,7 +118,7 @@ public class ItemModelMap extends ItemModelStandard {
             }
             GLRenderer.popFrame();
         } else {
-            super.renderFirstPerson(tessellator, itemRenderer, player, itemStack, lightmapCoord, partialTick);
+            super.renderFirstPerson(tessellator, itemRenderer, player, itemStack, lightIndex, partialTick);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
index 2d01d27c5..f68209e11 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
@@ -16,7 +16,7 @@ public class ItemModelNone extends ItemModel{
 
 
     @Override
-    public void render(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, int lightmapCoord, final float partialTick, final boolean mirrorX) {
+    public void render(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, byte lightIndex, final float partialTick, final boolean mirrorX) {
 
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 85db19ea1..bc60db4a4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
@@ -13,6 +12,7 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
@@ -56,7 +56,7 @@ public class ItemModelStandard extends ItemModel{
     }
 
     @Override
-    public void render(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, int lightmapCoord, final float partialTick, final boolean mirrorX) {
+    public void render(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, @NotNull final String displayPosId, final boolean items3d, final int clusterSize, byte lightIndex, final float partialTick, final boolean mirrorX) {
         random.setSeed(187L);
         final DisplayPos displayPos = getDisplayPos(displayPosId);
 
@@ -71,7 +71,7 @@ public class ItemModelStandard extends ItemModel{
                 final float offY = 0;
                 final float offZ = 0.1f * i;
                 GLRenderer.modelM4f().translate(offX, offY, offZ);
-                renderSingle(tessellator, holder, itemStack, true, lightmapCoord, getColor(itemStack), partialTick, mirrorX);
+                renderSingle(tessellator, holder, itemStack, true, lightIndex, getColor(itemStack), partialTick, mirrorX);
                 GLRenderer.modelM4f().translate(-offX, -offY, -offZ);
             }
         } else {
@@ -85,17 +85,17 @@ public class ItemModelStandard extends ItemModel{
                     rOffZ = ((random.nextFloat() * 2.0F - 1.0F) * 0.2F) / displayPos.sz;
                 }
                 GLRenderer.modelM4f().translate(rOffX, rOffY, rOffZ);
-                renderSingle(tessellator, holder, itemStack, false, lightmapCoord, getColor(itemStack), partialTick, mirrorX);
+                renderSingle(tessellator, holder, itemStack, false, lightIndex, getColor(itemStack), partialTick, mirrorX);
                 GLRenderer.modelM4f().translate(-rOffX, -rOffY, -rOffZ);
             }
         }
     }
 
-    protected void renderSingle(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, final boolean items3d, int lightmapCoord, int color, final float partialTick, final boolean mirrorX) {
-        renderCoordinate(tessellator, getIcon(holder, itemStack), this.itemfullBright ? LightmapHelper.getLightmapCoord(15, 15) : lightmapCoord, color, items3d, mirrorX);
+    protected void renderSingle(@NotNull final TessellatorGeneral tessellator, @Nullable final Entity holder, @NotNull final ItemStack itemStack, final boolean items3d, byte lightIndex, int color, final float partialTick, final boolean mirrorX) {
+        renderCoordinate(tessellator, getIcon(holder, itemStack), this.itemfullBright ? LightIndexHelper.lightIndex2i(15, 15) : lightIndex, color, items3d, mirrorX);
     }
 
-    protected void renderCoordinate(@NotNull final TessellatorGeneral tessellator, @NotNull final IconCoordinate coordinate, int lightmap, int color, final boolean items3d, final boolean mirrorX) {
+    protected void renderCoordinate(@NotNull final TessellatorGeneral tessellator, @NotNull final IconCoordinate coordinate, byte lightIndex, int color, final boolean items3d, final boolean mirrorX) {
         final double cUMin = mirrorX ? coordinate.getIconUMax() : coordinate.getIconUMin();
         final double cUMax = mirrorX ? coordinate.getIconUMin() : coordinate.getIconUMax();
         final double cVMin = coordinate.getIconVMin();
@@ -108,7 +108,7 @@ public class ItemModelStandard extends ItemModel{
             final int pxW = coordinate.width;
 
             tessellator.startDrawingQuads();
-            tessellator.setLightmapCoord1i(lightmap);
+            tessellator.setLightmapCoord1i(lightIndex);
             tessellator.setColor1i(color);
             // front
             tessellator.setNormal(0, 0, -1);
@@ -172,7 +172,7 @@ public class ItemModelStandard extends ItemModel{
             tessellator.draw();
         } else {
             tessellator.startDrawingQuads();
-            tessellator.setLightmapCoord1i(lightmap);
+            tessellator.setLightmapCoord1i(lightIndex);
             tessellator.setColor1i(color);
             tessellator.setNormal(0, 1, 0);
             tessellator.addVertexWithUV(-0.5,  0.5, 0, cUMin, cVMin);
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
index 9aa8f30be..f2cceb4e8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/Particle.java
@@ -2,13 +2,13 @@ package net.minecraft.client.render.particle;
 
 import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.render.ParticleEngine;
-import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
@@ -39,7 +39,7 @@ public class Particle {
     protected float rCol;
     protected float gCol;
     protected float bCol;
-    protected int cachedLightmapCoord;
+    protected byte cachedLightmapCoord;
 
     public double x = 0;
     public double y = 0;
@@ -93,7 +93,7 @@ public class Particle {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
     }
 
     /**
@@ -119,7 +119,7 @@ public class Particle {
     }
 
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -279,7 +279,7 @@ public class Particle {
      */
     public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setLightmapCoord1i(getLightIndex(partialTick));
         t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
@@ -316,65 +316,30 @@ public class Particle {
         return calcBrightness(partialTick);
     }
 
-    public int calcLightmap(float partialTick) {
-        if (Global.accessor.isFullbrightEnabled()) return 15 << 20 | 15;
+    public byte calcLightIndex(float partialTick) {
+        if (Global.accessor.isFullbrightEnabled()) return LightIndexHelper.lightIndex2i(15, 15);
         TilePos blockPos = new TilePos(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick));
 
-        final int skylight;
-        final int blocklight;
+        byte lightIndex = 0;
         if (this.world.getBlockLitInteriorSurface(blockPos)) {
             TilePos queryPos = new TilePos();
 
-            int bU = this.world.getSavedLightValue(LightLayer.Block, blockPos.up(queryPos));
-            final int bW = this.world.getSavedLightValue(LightLayer.Block, blockPos.west(queryPos));
-            final int bE = this.world.getSavedLightValue(LightLayer.Block, blockPos.east(queryPos));
-            final int bS = this.world.getSavedLightValue(LightLayer.Block, blockPos.south(queryPos));
-            final int bN = this.world.getSavedLightValue(LightLayer.Block, blockPos.north(queryPos));
-            if (bW > bU) {
-                bU = bW;
-            }
-            if (bE > bU) {
-                bU = bE;
-            }
-            if (bS > bU) {
-                bU = bS;
-            }
-            if (bN > bU) {
-                bU = bN;
-            }
-            blocklight = bU;
-
-            int sU = this.world.getSavedLightValue(LightLayer.Sky, blockPos.up(queryPos));
-            final int sW = this.world.getSavedLightValue(LightLayer.Sky, blockPos.west(queryPos));
-            final int sE = this.world.getSavedLightValue(LightLayer.Sky, blockPos.east(queryPos));
-            final int sS = this.world.getSavedLightValue(LightLayer.Sky, blockPos.south(queryPos));
-            final int sN = this.world.getSavedLightValue(LightLayer.Sky, blockPos.north(queryPos));
-            if (sW > sU) {
-                sU = sW;
-            }
-            if (sE > sU) {
-                sU = sE;
-            }
-            if (sS > sU) {
-                sU = sS;
-            }
-            if (sN > sU) {
-                sU = sN;
-            }
-            skylight = sU;
-
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.up(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.west(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.east(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.south(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.north(queryPos)));
         } else {
-            skylight = this.world.getSavedLightValue(LightLayer.Sky, blockPos);
-            blocklight = this.world.getSavedLightValue(LightLayer.Block, blockPos);
+            lightIndex = this.world.getSavedLightIndex(blockPos);
         }
 
-        return this.world.getLightmapCoord(skylight, blocklight);
+        return lightIndex;
     }
 
-    public int getLightmap(float partialTick) {
+    public byte getLightIndex(float partialTick) {
         return this.cachedLightmapCoord;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
index 014541f3c..7c01c1ae3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleArrowGolden.java
@@ -45,7 +45,7 @@ public class ParticleArrowGolden extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
index 20397c62e..2ae163ce5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleAsh.java
@@ -16,7 +16,7 @@ public class ParticleAsh extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
index a61e89499..e03155d13 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
@@ -6,7 +6,7 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.enums.LightLayer;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -46,7 +46,7 @@ public class ParticleBlockBreaking extends Particle {
     @Override
     public void render(@NotNull TessellatorParticle t, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setLightmapCoord1i(getLightIndex(partialTick));
         t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
@@ -56,61 +56,26 @@ public class ParticleBlockBreaking extends Particle {
     }
 
     @Override
-    public int calcLightmap(float partialTick) {
-        if (Global.accessor.isFullbrightEnabled()) return 15 << 20 | 15;
+    public byte calcLightIndex(float partialTick) {
+        if (Global.accessor.isFullbrightEnabled()) return LightIndexHelper.lightIndex2i(15, 15);
         TilePos blockPos = new TilePos(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick));
 
-        final int skylight;
-        final int blocklight;
-        if (this.world.getBlockLitInteriorSurface(blockPos) || blockPos.equals(this.initPos)) {
+        byte lightIndex = 0;
+        if (this.world.getBlockLitInteriorSurface(blockPos) || blockPos.equals(initPos)) {
             TilePos queryPos = new TilePos();
 
-            int bU = this.world.getSavedLightValue(LightLayer.Block, blockPos.up(queryPos));
-            final int bW = this.world.getSavedLightValue(LightLayer.Block, blockPos.west(queryPos));
-            final int bE = this.world.getSavedLightValue(LightLayer.Block, blockPos.east(queryPos));
-            final int bS = this.world.getSavedLightValue(LightLayer.Block, blockPos.south(queryPos));
-            final int bN = this.world.getSavedLightValue(LightLayer.Block, blockPos.north(queryPos));
-            if (bW > bU) {
-                bU = bW;
-            }
-            if (bE > bU) {
-                bU = bE;
-            }
-            if (bS > bU) {
-                bU = bS;
-            }
-            if (bN > bU) {
-                bU = bN;
-            }
-            blocklight = bU;
-
-            int sU = this.world.getSavedLightValue(LightLayer.Sky, blockPos.up(queryPos));
-            final int sW = this.world.getSavedLightValue(LightLayer.Sky, blockPos.west(queryPos));
-            final int sE = this.world.getSavedLightValue(LightLayer.Sky, blockPos.east(queryPos));
-            final int sS = this.world.getSavedLightValue(LightLayer.Sky, blockPos.south(queryPos));
-            final int sN = this.world.getSavedLightValue(LightLayer.Sky, blockPos.north(queryPos));
-            if (sW > sU) {
-                sU = sW;
-            }
-            if (sE > sU) {
-                sU = sE;
-            }
-            if (sS > sU) {
-                sU = sS;
-            }
-            if (sN > sU) {
-                sU = sN;
-            }
-            skylight = sU;
-
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.up(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.west(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.east(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.south(queryPos)));
+            lightIndex = LightIndexHelper.max(lightIndex, this.world.getSavedLightIndex(blockPos.north(queryPos)));
         } else {
-            skylight = this.world.getSavedLightValue(LightLayer.Sky, blockPos);
-            blocklight = this.world.getSavedLightValue(LightLayer.Block, blockPos);
+            lightIndex = this.world.getSavedLightIndex(blockPos);
         }
 
-        return this.world.getLightmapCoord(skylight, blocklight);
+        return lightIndex;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
index fc9bb4af9..1587e0b04 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBubble.java
@@ -24,7 +24,7 @@ public class ParticleBubble extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
index 27ca2a5bc..e449080c7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleExplode.java
@@ -16,7 +16,7 @@ public class ParticleExplode extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
index 4cab8c024..aef5fb994 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.tessellator.TessellatorParticle;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -125,7 +126,7 @@ public class ParticleFirefly extends Particle {
         float x = (float) (this.xo + (this.x - this.xo) * partialTick);
         float y = (float) (this.yo + (this.y - this.yo) * partialTick);
         float z = (float) (this.zo + (this.z - this.zo) * partialTick);
-        t.setLightmapCoord1i(getLightmap(partialTick));
+        t.setLightmapCoord1i(getLightIndex(partialTick));
         t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
         t.addVertexWithUV(x + r, y - r, z / 10, u2, v2);
         t.addVertexWithUV(x + r, y + r, z / 10, u2, v0);
@@ -134,8 +135,8 @@ public class ParticleFirefly extends Particle {
     }
 
     @Override
-    public int calcLightmap(float partialTick) {
-        return LightmapHelper.setBlocklightValue(super.calcLightmap(partialTick), 15);
+    public byte calcLightIndex(float partialTick) {
+        return LightIndexHelper.setBlockLight(super.calcLightIndex(partialTick), 15);
     }
 
     public void tickGui() {
@@ -164,7 +165,7 @@ public class ParticleFirefly extends Particle {
 
     @Override
     public void tick() {
-        this.cachedLightmapCoord = calcLightmap(1f);
+        this.cachedLightmapCoord = calcLightIndex(1f);
         this.sinTimer++;
         if (this.sinTimer > 100) {
             this.sinTimer = 0;
